function love.load()
	bg = love.graphics.newImage("bg.png")
	princess = {
		love.graphics.newImage("princess-neutral.png"),
		love.graphics.newImage("princess-happy.png"),
	}
	guy = {
		love.graphics.newImage("guy-stand.png"),
		love.graphics.newImage("guy-throw.png"),
		love.graphics.newImage("guy-wait.png"),
	}

	diamond = love.graphics.newImage("diamond.png")

	diamondsActive = {}
	--soundCharge = love.graphics.newAudio("")

	love.graphics.setLineWidth( 4 )
	love.graphics.setColorMode( "replace" )

	-- char status vars
	princessHappy = false
	guyCharging = false
	guyThrowing = false
	guyThrowTime = 0
	guyChargeTime = 0
	guyChargePower = 0
	guyThrowAngle = 0
	allTime = 0
	throwRotTime = 0
end

function love.update(dt)
	allTime = allTime + dt
	if guyThrowing == true then
		guyThrowTime = guyThrowTime + dt
	end
	if guyCharging then
		guyChargeTime = guyChargeTime + dt
		guyChargePower = (math.abs(math.sin(guyChargeTime/1)))*10
	else
		throwRotTime = throwRotTime + dt
		guyThrowAngle = math.sin(math.abs(throwRotTime/100))
	end
	if guyThrowTime > 1 then
		guyThrowing = false
		guyThrowTime = 0
	end
	for i,v in ipairs(diamondsActive) do
		v.pos = { v.pos[1] + (v.force * v.angle[1]), v.pos[2] - (v.force * v.angle[2]) }
		if v.pos[1] > 664 or v.pos[2] < -64 then
			table.remove(diamondsActive, i)
		end
	end
end

function love.draw()
	love.graphics.draw(bg, 0, 0)
	if guyThrowing then
		love.graphics.draw(guy[2],100,294)
	elseif guyCharging then
		love.graphics.draw(guy[1],100,294)
	else
		love.graphics.draw(guy[3],100,294)
	end
	if princessHappy then
		love.graphics.draw(princess[2], 360, 70)
	else
		love.graphics.draw(princess[1], 360, 70)
	end
	love.graphics.setColor( 150, 150, 150, 200 )
	love.graphics.line(100, 280, 100 + 100*math.abs(math.sin(guyThrowAngle*((4*2.5)*7))), 280 - 100*math.abs(math.cos(guyThrowAngle*((4*2.5)*7))))
	if guyCharging then
		love.graphics.setColor( 250, 250, 250, 200 )
		love.graphics.line(
			100, 280,
			100 + 10 * guyChargePower * math.abs( math.sin( guyThrowAngle * ((4 * 2.5) * 7))),
			280 - 10 * guyChargePower * math.abs( math.cos( guyThrowAngle * ((4 * 2.5) * 7)))
		)
	end
	for i,v in ipairs(diamondsActive) do
		love.graphics.draw(diamond, v.pos[1], v.pos[2])
	end
end

function love.keypressed(key, unicode)
	if key == ' ' then
		guyCharging = true
	elseif key == 'q' or key == 'escape' then
		love.event.push('q') -- quit the game 
	end
end

function love.keyreleased(key, unicode)
	if key==' ' then
		guyCharging = false
		guyThrowing = true
		guyChargeTime = 0
		addDiamond(guyChargePower)
	end
end

function addDiamond(force)
	table.insert(
		diamondsActive,
		{
			force = force * 4,
			pos = {100,270},
			angle = {
				math.abs( math.sin( guyThrowAngle * ((4 * 2.5) * 7))),
				math.abs( math.cos( guyThrowAngle * ((4 * 2.5) * 7)))
			} 
		}
	)
end
